#include <kdialog.h>
#include <klocale.h>
/****************************************************************************
** Form implementation generated from reading ui file './soundwidget.ui'
**
** Created by: The User Interface Compiler ($Id: qt/main.cpp   3.3.8   edited Jan 11 14:47 $)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "soundwidget.h"

#include <qvariant.h>
#include <qpushbutton.h>
#include <qgroupbox.h>
#include <qcheckbox.h>
#include <qlabel.h>
#include <qspinbox.h>
#include <qcombobox.h>
#include <qlineedit.h>
#include <qbuttongroup.h>
#include <qradiobutton.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>

/*
 *  Constructs a SoundWidget as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 */
SoundWidget::SoundWidget( QWidget* parent, const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
    if ( !name )
	setName( "SoundWidget" );
    SoundWidgetLayout = new QGridLayout( this, 1, 1, 11, 6, "SoundWidgetLayout"); 

    GroupBox1 = new QGroupBox( this, "GroupBox1" );
    GroupBox1->setFrameShadow( QGroupBox::Sunken );
    GroupBox1->setColumnLayout(0, Qt::Vertical );
    GroupBox1->layout()->setSpacing( 6 );
    GroupBox1->layout()->setMargin( 11 );
    GroupBox1Layout = new QGridLayout( GroupBox1->layout() );
    GroupBox1Layout->setAlignment( Qt::AlignTop );
    spacer3 = new QSpacerItem( 160, 16, QSizePolicy::Expanding, QSizePolicy::Minimum );
    GroupBox1Layout->addItem( spacer3, 1, 1 );

    _autoMute = new QCheckBox( GroupBox1, "_autoMute" );

    GroupBox1Layout->addWidget( _autoMute, 0, 0 );

    layout8 = new QHBoxLayout( 0, 0, 6, "layout8"); 

    textLabel1 = new QLabel( GroupBox1, "textLabel1" );
    layout8->addWidget( textLabel1 );
    spacer21 = new QSpacerItem( 46, 16, QSizePolicy::Expanding, QSizePolicy::Minimum );
    layout8->addItem( spacer21 );

    _volumeIncrement = new QSpinBox( GroupBox1, "_volumeIncrement" );
    _volumeIncrement->setMinValue( 1 );
    _volumeIncrement->setValue( 4 );
    layout8->addWidget( _volumeIncrement );

    GroupBox1Layout->addLayout( layout8, 1, 0 );
    spacer4 = new QSpacerItem( 179, 16, QSizePolicy::Expanding, QSizePolicy::Minimum );
    GroupBox1Layout->addItem( spacer4, 2, 1 );

    layout9 = new QHBoxLayout( 0, 0, 6, "layout9"); 

    TextLabel2 = new QLabel( GroupBox1, "TextLabel2" );
    layout9->addWidget( TextLabel2 );
    spacer22 = new QSpacerItem( 21, 11, QSizePolicy::Expanding, QSizePolicy::Minimum );
    layout9->addItem( spacer22 );

    _delayOnChange = new QSpinBox( GroupBox1, "_delayOnChange" );
    _delayOnChange->setMaxValue( 200 );
    _delayOnChange->setMinValue( 10 );
    _delayOnChange->setValue( 30 );
    layout9->addWidget( _delayOnChange );

    GroupBox1Layout->addLayout( layout9, 2, 0 );

    SoundWidgetLayout->addWidget( GroupBox1, 1, 0 );

    GroupBox3 = new QGroupBox( this, "GroupBox3" );
    GroupBox3->setColumnLayout(0, Qt::Vertical );
    GroupBox3->layout()->setSpacing( 6 );
    GroupBox3->layout()->setMargin( 11 );
    GroupBox3Layout = new QGridLayout( GroupBox3->layout() );
    GroupBox3Layout->setAlignment( Qt::AlignTop );

    _configure = new QPushButton( GroupBox3, "_configure" );

    GroupBox3Layout->addWidget( _configure, 0, 3 );

    _mixer = new QComboBox( FALSE, GroupBox3, "_mixer" );

    GroupBox3Layout->addWidget( _mixer, 0, 2 );

    textLabel1_2 = new QLabel( GroupBox3, "textLabel1_2" );

    GroupBox3Layout->addMultiCellWidget( textLabel1_2, 0, 0, 0, 1 );

    _author = new QLineEdit( GroupBox3, "_author" );
    _author->setReadOnly( TRUE );

    GroupBox3Layout->addMultiCellWidget( _author, 1, 1, 1, 3 );

    _description = new QLineEdit( GroupBox3, "_description" );
    _description->setReadOnly( TRUE );

    GroupBox3Layout->addMultiCellWidget( _description, 2, 2, 1, 3 );

    textLabel18 = new QLabel( GroupBox3, "textLabel18" );

    GroupBox3Layout->addWidget( textLabel18, 1, 0 );

    textLabel17 = new QLabel( GroupBox3, "textLabel17" );

    GroupBox3Layout->addWidget( textLabel17, 2, 0 );

    SoundWidgetLayout->addWidget( GroupBox3, 0, 0 );
    spacer20 = new QSpacerItem( 20, 20, QSizePolicy::Minimum, QSizePolicy::Expanding );
    SoundWidgetLayout->addItem( spacer20, 3, 0 );

    buttonGroup1 = new QButtonGroup( this, "buttonGroup1" );
    buttonGroup1->setColumnLayout(0, Qt::Vertical );
    buttonGroup1->layout()->setSpacing( 6 );
    buttonGroup1->layout()->setMargin( 11 );
    buttonGroup1Layout = new QGridLayout( buttonGroup1->layout() );
    buttonGroup1Layout->setAlignment( Qt::AlignTop );

    textLabel1_3 = new QLabel( buttonGroup1, "textLabel1_3" );

    buttonGroup1Layout->addWidget( textLabel1_3, 0, 2 );

    _soundCardMixer = new QRadioButton( buttonGroup1, "_soundCardMixer" );
    _soundCardMixer->setChecked( FALSE );

    buttonGroup1Layout->addWidget( _soundCardMixer, 0, 0 );

    _tvCardMixer = new QRadioButton( buttonGroup1, "_tvCardMixer" );

    buttonGroup1Layout->addWidget( _tvCardMixer, 1, 0 );

    textLabel1_4 = new QLabel( buttonGroup1, "textLabel1_4" );

    buttonGroup1Layout->addWidget( textLabel1_4, 1, 2 );

    _soundCardVolume = new QSpinBox( buttonGroup1, "_soundCardVolume" );
    _soundCardVolume->setMaxValue( 100 );

    buttonGroup1Layout->addWidget( _soundCardVolume, 1, 3 );

    _tvVolume = new QSpinBox( buttonGroup1, "_tvVolume" );
    _tvVolume->setMaxValue( 100 );

    buttonGroup1Layout->addWidget( _tvVolume, 0, 3 );
    spacer7 = new QSpacerItem( 71, 21, QSizePolicy::Expanding, QSizePolicy::Minimum );
    buttonGroup1Layout->addItem( spacer7, 0, 1 );
    spacer8 = new QSpacerItem( 71, 21, QSizePolicy::Expanding, QSizePolicy::Minimum );
    buttonGroup1Layout->addItem( spacer8, 1, 1 );

    SoundWidgetLayout->addWidget( buttonGroup1, 2, 0 );
    languageChange();
    resize( QSize(545, 419).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( _soundCardMixer, SIGNAL( toggled(bool) ), _tvVolume, SLOT( setEnabled(bool) ) );
    connect( _tvCardMixer, SIGNAL( toggled(bool) ), _soundCardVolume, SLOT( setEnabled(bool) ) );

    // tab order
    setTabOrder( _mixer, _configure );
    setTabOrder( _configure, _author );
    setTabOrder( _author, _description );
    setTabOrder( _description, _autoMute );
    setTabOrder( _autoMute, _volumeIncrement );
    setTabOrder( _volumeIncrement, _delayOnChange );

    // buddies
    TextLabel2->setBuddy( _delayOnChange );
}

/*
 *  Destroys the object and frees any allocated resources
 */
SoundWidget::~SoundWidget()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void SoundWidget::languageChange()
{
    QToolTip::add( this, QString::null );
    GroupBox1->setTitle( tr2i18n( "Sound Properties" ) );
    _autoMute->setText( tr2i18n( "Mute mixer element on exit" ) );
    QToolTip::add( _autoMute, tr2i18n( "Mute mixer on application exit" ) );
    QWhatsThis::add( _autoMute, tr2i18n( "Mute mixer on application exit. On some systems, TV sound is not automatically muted if the application is closed. Use this option as a work-around." ) );
    textLabel1->setText( tr2i18n( "Volume increment:" ) );
    _volumeIncrement->setSuffix( tr2i18n( " %" ) );
    QToolTip::add( _volumeIncrement, tr2i18n( "Volume increment stepwidth" ) );
    QWhatsThis::add( _volumeIncrement, tr2i18n( "If volume is changed via hotkey or DCOP (mostly when using KDELIRC), it is incremented by the configured amount" ) );
    TextLabel2->setText( tr2i18n( "Volume restoration delay:\n"
"(on channel change)" ) );
    QWhatsThis::add( TextLabel2, tr2i18n( "Amount of time to elapse before volume is restored to its previous settings during channel changes.  Valid values are between 10 and 200 msecs.  Higher values usually means less static when quickly flipping through channels." ) );
    _delayOnChange->setSuffix( tr2i18n( "  msec" ) );
    QToolTip::add( _delayOnChange, tr2i18n( "Volume restoration delay" ) );
    QWhatsThis::add( _delayOnChange, tr2i18n( "Amount of time elapsed before volume is restored to its previous levels when changing channels.  Acceptable values are between 10 and 200 msecs.  Higher values usually mean less static when flipping through channels." ) );
    GroupBox3->setTitle( tr2i18n( "Mixer Driver Selection" ) );
    QToolTip::add( GroupBox3, QString::null );
    _configure->setText( tr2i18n( "Configure Mixer..." ) );
    QToolTip::add( _configure, tr2i18n( "Configure mixer options" ) );
    QWhatsThis::add( _configure, tr2i18n( "Configure mixer. On most systems, TV sound is connected to the \"Line\" or \"TV\" input." ) );
    QToolTip::add( _mixer, tr2i18n( "Select mixer driver" ) );
    QWhatsThis::add( _mixer, tr2i18n( "Mixer driver selector. Choose the mixer suitable for your system. On most modern Linux systems, the ALSA plugin is the correct choice." ) );
    textLabel1_2->setText( tr2i18n( "Select mixer driver:" ) );
    QToolTip::add( _author, tr2i18n( "Shows mixer driver author" ) );
    QWhatsThis::add( _author, QString::null );
    QToolTip::add( _description, tr2i18n( "Shows mixer driver description" ) );
    QWhatsThis::add( _description, QString::null );
    textLabel18->setText( tr2i18n( "Author:" ) );
    textLabel17->setText( tr2i18n( "Description:" ) );
    buttonGroup1->setTitle( tr2i18n( "Volume Is Controlled Using" ) );
    QToolTip::add( buttonGroup1, tr2i18n( "If you experience problems with volume control, select other method." ) );
    QWhatsThis::add( buttonGroup1, QString::null );
    textLabel1_3->setText( tr2i18n( "Corresponding TV Card Volume:" ) );
    _soundCardMixer->setText( tr2i18n( "Sound card mixer" ) );
    _tvCardMixer->setText( tr2i18n( "TV card mixer" ) );
    textLabel1_4->setText( tr2i18n( "Corresponding Sound Card Volume:" ) );
    _soundCardVolume->setSuffix( tr2i18n( " %" ) );
    _tvVolume->setSuffix( tr2i18n( " %" ) );
}

#include "soundwidget.moc"
